﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.IO.IsolatedStorage;
using System.IO;
using Microsoft.Phone;
namespace CanaryGuide.Converter
{
    public class ImageToString:IValueConverter
    {
        #region Interfaz
        object IValueConverter.Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string cadena = (string)value;

            if (cadena.Length > 0)
                return cadena;
           //Este método se llama sólo si el usuario es quién ha creado el contenido. Concretamente, es para acceder a sus datos.
            return cargarImagen(cadena);
         
        }

        object IValueConverter.ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
        #endregion

        private object cargarImagen(string path)
        {

            using(var store = IsolatedStorageFile.GetUserStoreForApplication())
            {
             
                // Read the saved image back out
                if(!store.FileExists(path))
                {
                    return null;
                }

                var fileStream = store.OpenFile(path, FileMode.Open, FileAccess.Read);
                var imageAsBitmap = PictureDecoder.DecodeJpeg(fileStream);

                // Display the read image in a control on the page called 'MyImage'
                return imageAsBitmap;
            }

        }
    }
}
