﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using CoreLibrary.Controlador.Filtros;
using GuideLibrary;
using System.Collections.Generic;
using System.ComponentModel;
namespace CanaryGuide
{
    public class GuideData :INotifyPropertyChanged
    {
      
        public GuideData()
        {
            
           
            this.LugarDeInteres = GestionGuide.Instance.LugaresDeInteres;
            this._filtrosLugarDeInteres = new List<string>();
        }

        #region Var y properties
        private List<LugarDeInteres> _LugarDeInteres;
        private List<string> _filtrosLugarDeInteres;
        public List<string> FiltrosLugarDeInteres
        {
            get { return _filtrosLugarDeInteres; }
            set { _filtrosLugarDeInteres = value; }
        }
        public List<LugarDeInteres> LugarDeInteres
        {
            get { return _LugarDeInteres; }
            set
            {
                _LugarDeInteres = value;
                this.NotificarCambio("LugarDeInteres");
            }
        }
        #endregion
        #region Filtros
        public void aplicarFiltroComida(string seleccion)
        {
            //Si se pulsa todos, se inicializan los filtros de cero.
            if (seleccion.Contains("all"))
            {
                this.FiltrosLugarDeInteres = new List<string>();
                this.LugarDeInteres = GestionGuide.Instance.LugaresDeInteres;
            }
            else if (seleccion.Contains("[X]"))
            {
                this.FiltrosLugarDeInteres.Remove(seleccion.Substring(0, seleccion.Length - 4));  //Se elimina el filtro que se acaba de aplicar de la lista de filtros aplicados.
                this.LugarDeInteres = GestionGuide.Instance.LugaresDeInteres;                           //Se cargan todas las comdias
                foreach (var filtro in this.FiltrosLugarDeInteres)                                 //Se vuelven a aplicar todos los filtros.
                {
                    ElementoOcurrencia eo = ElementoOcurrencia.fromString(filtro);
                    this.LugarDeInteres = FiltroTBool<LugarDeInteres>.aplicarFiltro(this.LugarDeInteres, eo, GestionGuide.Instance.Cod);
                }
            }
            else //Si no estaba previamente seleccionado el filtro, se aplica.
            {
                ElementoOcurrencia eo = ElementoOcurrencia.fromStringEntero(seleccion);
                this.FiltrosLugarDeInteres.Add(eo.Nombre);
                this.LugarDeInteres = FiltroTBool<LugarDeInteres>.aplicarFiltro(this.LugarDeInteres, eo, GestionGuide.Instance.Cod);
            }


        }
        #endregion
        public event PropertyChangedEventHandler PropertyChanged;

        public void NotificarCambio(string propiedad)
        {
            if (PropertyChanged != null)
                new PropertyChangedEventArgs(propiedad);

        }
    }
    }

