﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using GuideLibrary;
using Microsoft.Phone.Shell;
using GuideLibrary.Weather;
using GuideLibrary.Places;
using Microsoft.Phone.Tasks;
using GuideLibrary.Resources;
using System.Resources;
using CoreLibrary.Controlador.Filtros;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Datos;
namespace CanaryGuide
{
    
    public partial class MainPage : PhoneApplicationPage
    {

        private bool _placeLoaded;
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            ScriptCanaryGuide.run();
            // Set the data context of the listbox control to the sample data
          
            GestionGuide.Instance.GooglePlaces.ESearchDownloadComplete += rellenarPlaces;
            GestionGuide.Instance.GoogleWeather.EDownloadComplete += rellenarListTiempo;
            this.progressBarPlaces.Visibility = Visibility.Visible;
            this.progressBarTiempo.Visibility = Visibility.Visible;
           


            GestionGuide.Instance.GooglePlaces.getSearch(28.280196, -16.581116); //Aqui se añadiría la geolocalizacion
            GestionGuide.Instance.GoogleWeather.getTime("Tenerife");
            _placeLoaded = false;
            this.listBoxLugarDeInteres.DataContext = GestionGuide.Instance.LugaresDeInteres;     
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);


            rellenarAppBarLugarDeInteres(GestionGuide.Instance.LugaresDeInteres);
            rellenarListLugarDeInteres(GestionGuide.Instance.LugaresDeInteres);
            asignarIdioma();
        }
        #region Recursos
        private void asignarIdioma()
        {

            this.PanoramaItemLugarDeInteres.Header = "De interés";//MessageInterfaz.LugaresDeInteres;

        }
        


        #endregion

        #region LugarDeInteres

        private void rellenarListLugarDeInteres(List<LugarDeInteres> interes)
        {
           
            listBoxLugarDeInteres.Items.Clear();

            foreach (var lt in interes)           
                listBoxLugarDeInteres.Items.Add(lt);
            

        }
        private void rellenarAppBarLugarDeInteres(List<LugarDeInteres> lugares)
        {
           
            this.ApplicationBar.MenuItems.Clear();
            List<Propiedad> propiedades = GestionDatos.Instance[LGuide.AtributoLugarDeInteres].Propiedades;
            List<ElementoOcurrencia> eos = FiltroTBool<LugarDeInteres>.generarFiltro(lugares, propiedades,GestionGuide.Instance.Cod);
            


            ApplicationBarMenuItem ab = new ApplicationBarMenuItem("all");
            ab.Click += ApplicationBarMenuItem_ClickInteres;
            this.ApplicationBar.MenuItems.Add(ab);
            foreach (ElementoOcurrencia item in eos)
            {
                ApplicationBarMenuItem abmi;
                if (GestionGuide.Instance.FiltrosLugares.Contains(item.Nombre))
                    abmi = new ApplicationBarMenuItem(item.Nombre + " [X]");
                else
                    abmi = new ApplicationBarMenuItem(item.ToString());
                abmi.Click += ApplicationBarMenuItem_ClickInteres;
                this.ApplicationBar.MenuItems.Add(abmi);
            }
           
           

        }


        protected void ApplicationBarMenuItem_ClickInteres(object sender, EventArgs e)
        {
            ApplicationBarMenuItem abmi = (ApplicationBarMenuItem)sender;
            string texto = abmi.Text;
            List<LugarDeInteres> lugaresDeInteres=(List<LugarDeInteres>)listBoxLugarDeInteres.DataContext;


            //Si se pulsa todos, se inicializan los filtros de cero.
            if (texto.Contains("all"))
              lugaresDeInteres = GestionGuide.Instance.LugaresDeInteres;
            
            else if (texto.Contains("[X]"))
            {
                GestionGuide.Instance.FiltrosLugares.Remove(texto.Substring(0, texto.Length - 4));  //Se elimina el filtro que se acaba de aplicar de la lista de filtros aplicados.
                string[] filtros = new string[GestionGuide.Instance.FiltrosLugares.Count];
                GestionGuide.Instance.FiltrosLugares.CopyTo(filtros); //Se copian los filtros ya que en el siguiente paso se inicializan.
                lugaresDeInteres = GestionGuide.Instance.LugaresDeInteres;                         
                foreach (var filtro in filtros)                                 //Se vuelven a aplicar todos los filtros.
                {
                    ElementoOcurrencia eo = ElementoOcurrencia.fromString(filtro);
                    lugaresDeInteres = FiltroTBool<LugarDeInteres>.aplicarFiltro(lugaresDeInteres, eo, GestionGuide.Instance.Cod);
                }
            }
            else //Si no estaba previamente seleccionado el filtro, se aplica.
            {
               ElementoOcurrencia eo = ElementoOcurrencia.fromStringEntero(texto);
               GestionGuide.Instance.FiltrosLugares.Add(eo.Nombre);
               lugaresDeInteres = FiltroTBool<LugarDeInteres>.aplicarFiltro(lugaresDeInteres, eo, GestionGuide.Instance.Cod);
            }


            listBoxLugarDeInteres.DataContext = lugaresDeInteres;
            this.rellenarAppBarLugarDeInteres(lugaresDeInteres);
            this.rellenarListLugarDeInteres(lugaresDeInteres);

        }
        private void listBoxLugarDeInteres_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            LugarDeInteres li = (LugarDeInteres)listBoxLugarDeInteres.SelectedItem;
          
            NavigationService.Navigate(new Uri("/FichaLugarDeInteres.xaml?id=" + li.Id.ToString(), UriKind.Relative));
        }
        #endregion
        #region Weather
        private void rellenarListTiempo()
        {
            this.progressBarTiempo.Visibility = Visibility.Collapsed;
            listBoxTiempo.Items.Clear();
           
            foreach (var t in GestionGuide.Instance.GoogleWeather.Temperaturas)
                listBoxTiempo.Items.Add(t);
            
           
        }


        private void rellenarAppBarTiempo()
        {
           
          
            string [] palabras = {MessageInterfaz.Tenerife,MessageInterfaz.GranCanaria,MessageInterfaz.Lanzarote,
            MessageInterfaz.LaPalma,MessageInterfaz.Fuerteventura,MessageInterfaz.LaGomera,MessageInterfaz.ElHierro};
            

            foreach (var p in palabras)
            {
                ApplicationBarMenuItem ab = new ApplicationBarMenuItem(p);
                ab.Click+=clickAppBarTiempo;
                this.ApplicationBar.MenuItems.Add(ab);
            }
            
        }
        protected void clickAppBarTiempo(object sender, EventArgs e)
        {
            ApplicationBarMenuItem ab = (ApplicationBarMenuItem)sender;
            GestionGuide.Instance.GoogleWeather.getTime(ab.Text);
            GestionGuide.Instance.GoogleWeather.EDownloadComplete += rellenarListTiempo;

        }
        #endregion

        #region Places
        private void rellenarPlaces()
        {
            this.progressBarPlaces.Visibility = Visibility.Collapsed;
            this.listBoxPlaces.Visibility = Visibility.Visible;
            listBoxPlaces.Items.Clear();
            this.listBoxPlaces.DataContext = GestionGuide.Instance.GooglePlaces.sitios;
            foreach (var s in GestionGuide.Instance.GooglePlaces.sitios)
                listBoxPlaces.Items.Add(s);
            this._placeLoaded = true;
            if (this.PanoramaMain.SelectedItem.Equals(this.PanoramaItemPlaces))
                rellenarAppBarPlaces(GestionGuide.Instance.GooglePlaces.sitios);
        }
        private void rellenarPlaces(List<Place> places)
        {
            listBoxPlaces.Items.Clear();
            this.listBoxPlaces.DataContext = places;
            foreach (var s in places)
                listBoxPlaces.Items.Add(s);

           

        }


        private void listBoxPlaces_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Place place = (Place)listBoxPlaces.SelectedItem;
           

            this.listBoxPlaces.Visibility = Visibility.Visible;
            this.progressBarPlaces.Visibility = Visibility.Collapsed;
            NavigationService.Navigate(new Uri("/FichaPlaces.xaml?reference="+place.Reference, UriKind.Relative));
        
        }

        private void rellenarAppBarPlaces(List<Place> places)
        {
            this.ApplicationBar.MenuItems.Clear();
            IEnumerable<string> palabras = places.SelectMany(t => t.Tipo);
            List<ElementoOcurrencia> elementosO = new List<ElementoOcurrencia>();
            foreach (var p in palabras)
                new ElementoOcurrencia(p).incrementarAñadirLista(elementosO);


            ApplicationBarMenuItem all = new ApplicationBarMenuItem("all"); 
            all.Click += clickAppBarPlaces;
            this.ApplicationBar.MenuItems.Add(all);

            foreach (var item in elementosO)
            {
                ApplicationBarMenuItem abmi;
                if (GestionGuide.Instance.GooglePlaces.filtrosAplicados.Contains(item.Nombre))
                    abmi = new ApplicationBarMenuItem(item.Nombre + " [X]");
                else
                    abmi = new ApplicationBarMenuItem(item.ToString());



                abmi.Click += clickAppBarPlaces;
                this.ApplicationBar.MenuItems.Add(abmi);
            }
        }

        protected void clickAppBarPlaces(object sender, EventArgs e)
        {
            ApplicationBarMenuItem ab = (ApplicationBarMenuItem)sender;
            string texto = ab.Text;
            List<Place> places;

            if(texto.Equals("all"))
                places = GestionGuide.Instance.GooglePlaces.sitios;
            else if (texto.Contains("[X]"))
            {
                GestionGuide.Instance.GooglePlaces.filtrosAplicados.Remove(texto.Substring(0, texto.Length - 4));   //Se elimina el filtro que se acaba de aplicar de la lista de filtros aplicados.
                string[] filtros = new string[GestionGuide.Instance.GooglePlaces.filtrosAplicados.Count];           //Se copian los filtros para no perder los valores (se reinician cuando se llama a GooglePlaces.sitios) Al aplicarlos se vuelven a cargar
                GestionGuide.Instance.GooglePlaces.filtrosAplicados.CopyTo(filtros);       
                places = GestionGuide.Instance.GooglePlaces.sitios;                                                 //Se cargan todas los sitios
              


                foreach (var filtro in filtros)                                                                     //Se vuelven a aplicar todos los filtros.
                   places = GestionGuide.Instance.GooglePlaces.getPlaceWithFilter(filtro,places);
                
            }
            else
                places = GestionGuide.Instance.GooglePlaces.getPlaceWithFilter(ElementoOcurrencia.fromStringEntero(texto).Nombre, (List<Place>)listBoxPlaces.DataContext);
           
            
            rellenarPlaces(places);
            rellenarAppBarPlaces(places);
           

        }

        #endregion


        #region AppBar
        private void PanoramaMain_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Dispatcher.BeginInvoke(cargarAppBar);
        }
        //Los eventos de cada item están dentro del region del tipo de item.
        private void cargarAppBar()
        {


            PanoramaItem pi = (PanoramaItem)this.PanoramaMain.SelectedItem;
            this.ApplicationBar.MenuItems.Clear();

            if(pi.Equals(this.PanoramaItemWeather))
                this.rellenarAppBarTiempo();

            if (pi.Equals(this.PanoramaItemPlaces) && this._placeLoaded)
            {
                List<Place> sitios = (List<Place>)this.listBoxPlaces.DataContext;
                if (sitios == null)
                    sitios = GestionGuide.Instance.GooglePlaces.sitios;

                this.rellenarAppBarPlaces(sitios);


            }

            if (pi.Equals(this.PanoramaItemLugarDeInteres))
            {
                {
                    List<LugarDeInteres> interes = (List<LugarDeInteres>)this.listBoxLugarDeInteres.DataContext;
                    if (interes == null)
                        interes = GestionGuide.Instance.LugaresDeInteres;

                    this.rellenarAppBarLugarDeInteres(interes);


                }

            }




          

        }

        #endregion



        // Load data for the ViewModel Items
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
          
        }

      

      

      
    }
}