﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Xml.Linq;
using System.Net;
using System.IO;
#if WINDOWS_PHONE
using ImageTools.IO.Png;
using ImageTools;
#elif MONO
using MonoTouch.UIKit;
#endif
namespace GuideLibrary.Places
{
   public class Place
    {

        #if WINDOWS_PHONE
         public ExtendedImage Icon { get; set; }
		#elif MONO
		public UIImage Icon {get;set;}
		#endif
       
        public string Nombre { get; set; }
        public string Reference { get; set; }
        public List<string> Tipo { get; set; }
        public string Latitud { get; set; }
        public string Longitud { get; set; }
        public string Url { get; set; }
        public double Rating { get; set;}
        public bool   isLoad { get; set; }


        public Place()
        {
            this.isLoad = false;
        }

        public void Detalles_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            //TODO Hacer las comprobaciones pertinentes.
          
            XElement XMLCadena = XElement.Parse(e.Result);
            foreach (var nodo in XMLCadena.Nodes())
            {
                XElement elemento = (XElement)nodo;
                if (!elemento.Name.LocalName.Equals("result"))
                    continue;

                this.Url = elemento.Element("url").Value;
                this.obtenerUrlImagen(this.Url);
                this.isLoad = true;
            }
        }

        private  void obtenerUrlImagen(string url)
        {
            if (string.IsNullOrEmpty(url))
                return;
           
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                request.UserAgent = "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; Smartphone; 176x220)";

                request.BeginGetResponse(new AsyncCallback(GetRequestURLAndSetImage), request);
           
            

        }

        private void GetRequestURLAndSetImage(IAsyncResult result)
        {           
                HttpWebRequest request = (HttpWebRequest)result.AsyncState;
                WebResponse response = request.EndGetResponse(result);

                StreamReader sr = new StreamReader(response.GetResponseStream());
                string rss = sr.ReadToEnd();
                sr.Close();
			
                int indece = rss.IndexOf("<img class=\"paupyn\"");
                if (indece != -1)
                {
                    string urlImagen = rss.Substring(indece, 100).Split('"')[3];
                    if (!urlImagen.Contains("panoramio"))
                        return;

					#if WINDOWS_PHONE
                    ImageTools.IO.Decoders.AddDecoder<PngDecoder>();
                    this.Icon = new ExtendedImage();
                    this.Icon.UriSource = new Uri(urlImagen, UriKind.Absolute);
					
					#elif MONO
					this.Icon = UIImage.LoadFromData(MonoTouch.Foundation.NSData.FromArray(new WebClient().DownloadData(urlImagen)));
					#endif
					//QUIZA VOLVER A LLAMAR AL MOTOR DE REDENDERIZACIÓN!?
                }
        }
        
    }
}
