﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Controlador;
using CoreLibrary.Controlador.Tipo;
using CoreLibrary.Controlador.Colecciones;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Literales;
using CoreLibrary.Datos.Modelo;
using   CoreLibrary.Datos;
namespace CoreLibrary.Controlador.Filtros
{
    public static  class FiltroTBool<T>   
        where T: Elemento
    {


        #region MetodosPublicos
        /// <summary>
        /// Para una lista de elementosControlador y una lista de Propiedadesontrolador (tipo TBOOLEAN) devuelve una lista de
        /// elementosOcurrencias con las ocurrencias para el idioma pasado por parametro.
        /// </summary>
        /// <param name="elementosC">Lista sobre la que se va a generar</param>
        /// <param name="propiedadfiltros">Lista de propiedades que van a generar las ocurrencia</param>
        /// <param name="codIdioma">Idioma en el que se estableceran las propiedades</param>
        /// <returns></returns>
        public static List<ElementoOcurrencia> generarFiltro(List<T> elementosC, List<Propiedad> propiedadfiltros,string codIdioma = "es")
        {
       
            List<ElementoOcurrencia> elementosO = new List<ElementoOcurrencia>();
            foreach (var filtro in propiedadfiltros)
            {
                List<T> elementosCFiltrados = (from e in elementosC
                                               where e.getValorPorNombre(filtro.Nombre)!=null && bool.Parse(e.getValorPorNombre(filtro.Nombre).Valor)
                                               select e).ToList();
               
                foreach (var elementoC in elementosCFiltrados)
                    new ElementoOcurrencia(filtro.devolverTraduccionPropiedad(codIdioma)).incrementarAñadirLista(elementosO);

            }
            return elementosO;
        }
        #endregion






        /// <summary>
        /// Para una lista de elementos y una propiedad controlador (tboolean) descarta aquellos elementos que no tengan los  filtros establecidos.
        /// </summary>
        /// <param name="elementosC">Lista de elementos sobre los que se va a filtrar</param>
        /// <param name="propiedadFiltro">Filtro a aplicar</param>
        /// <returns></returns>
        public static List<T> aplicarFiltro(List<T> elementosC, ElementoOcurrencia elementoFiltro,string cod)
        {
            Propiedad propiedadFiltro = GestionDatos.Instance.Propiedades.FirstOrDefault(
                pc=>pc.comprobarSiLaTraduccionPerteneceAEstaPropiedad(elementoFiltro.Nombre,cod));

            return (from e in elementosC
                    where bool.Parse(e.getValorPorNombre(propiedadFiltro.Nombre).Valor)
                    select e).ToList();

        }
        

        
    
    
    
    }
}
