﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Datos;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Literales;

namespace CoreLibrary.Controlador.Tipo
{
     
   public class TDT:TDate
    {
       private List<ValoresEP> vcs;
        /// <summary>
        /// Crea una nueva instancia del tipo TDT de la forma {FECHAINICIO}{SEPARADOR}|{FECHAFIN}{SEPARADOR}{TEXTO}
        /// </summary>
        /// <param name="ec"></param>
        /// <param name="pc"></param>
        /// <param name="valor"></param>
        ///  List<ValorControlador> vcs;
       /// <summary>
        
        public  TDT(Elemento ec, Propiedad pc,DateTime fechaInicio,DateTime fechaFin, string valorString,string cod)
        {
            this.nuevo(ec, pc, fechaInicio, fechaFin, valorString, cod);
        }

        public TDT(ValoresEP vc)
        {
            this.cargar(vc);
        }
        protected void nuevo(Elemento ec, Propiedad pc, DateTime fechaInicio, DateTime fechaFin, string valorString, string cod)
        {
            Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
            string valor = fechaInicio.ToString() + LTipoPrimitivo.Separador + fechaFin.ToString() + LTipoPrimitivo.Separador + valorString;
            ValoresEP vc = new ValoresEP(ec, pc, valor, idioma);
            this.vcs = new List<ValoresEP>();
            this.vcs.Add(vc);
         this.cargar(ref vcs);
         
        }
        protected void cargar(ValoresEP vc)
        {
            this.vcs = new List<ValoresEP>();
            this.vcs.Add(vc);
          this.cargar(ref vcs);
            
        }
     
        /// <summary>
        /// Indexador, para obtener un valor pasar el codigo de idioma por indice.
        /// Para agregar un nuevo valor asignar o modificar uno existente pasar el codigo de idioma por indice., automaticamente se ejecutaran
        /// las operaciones pertinentes y se almacenara en la base de datos.
        ///
        /// </summary>
        /// <param name="cod"></param>
        /// <returns></returns>
        public string this[string cod]
        {
            get
            {

                Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
                ValoresEP vc = this.vcs.FirstOrDefault(v => v.Idioma.Id== idioma.Id);
                if (vc == null)
                    return string.Empty;
                return vc.Valor.Split(LTipoPrimitivo.Separador)[2];
            }
            set
            {

                Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
                ValoresEP vc = this.vcs.FirstOrDefault(v => v.Idioma.Id == idioma.Id);
                //Si ya contiene la propiedad la modifica
                if (vc != null)
                {
                    this.guardarValor(ref this.vcs, value,cod);
                }
                //Si no, crea una nueva y la añade
                else
                {
                    string valor = this.FechaInicio.ToString() + LTipoPrimitivo.Separador + this.FechaFin.ToString() + LTipoPrimitivo.Separador + value;
                    vc = new ValoresEP(this.Elemento, this.Propiedad, valor, idioma);
                    this.vcs.Add(vc);
                }
            }
        }

        
      
    }
}
