﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Datos;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Literales;
using CoreLibrary.Controlador;

using CoreLibrary.Controlador.Tipo;
namespace CoreLibrary.Controlador.Tipo
{
    /// <summary>
    /// Clase que tiene  dos fechas inicio y fin.
    /// En la base de datos se almacena como un string de la forma {FechaInicio}{Separador}{FechaFin} 
    /// </summary>
  
   public class TDate : TipoBase
    {
       protected TDate() { }
        public TDate(ValoresEP vc)
        {
            this.cargar(vc);
        }
        public TDate(Elemento ec, Propiedad pc, DateTime fechaInicio, DateTime fechaFin)
        {
           string valorCadena = fechaInicio.ToString() + LTipoPrimitivo.Separador + fechaFin.ToString();          
           this.ValoresEP= new ValoresEP(ec, pc, valorCadena);
           base.cargar(this.ValoresEP);
        }
        public DateTime FechaInicio
        {
            get
            {
                //Se carga el tipo dinámico (datetime) de la fuente (string) y se devuelve.
                DateTime fechaInicio = DateTime.Parse(this.consultarValor(0)); 
                return fechaInicio;
            }
            set
            {
                //se guarda el tipo como un int, aunque realmente es un boolean.
                this.guardarValor(0, value.ToString());
                
            }
        }

        public DateTime FechaFin
        {

            get
            {
                //Se carga el tipo dinámico (datetime) de la fuente (string) y se devuelve.
                DateTime fechaInicio =DateTime.Parse(this.consultarValor(1));
                return fechaInicio;
            }
            set
            {
                //se guarda el tipo como un int, aunque realmente es un boolean.
                this.guardarValor(1, value.ToString());

            }
        }


     





    }
}
