﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Datos;


namespace CoreLibrary.Controlador.Tipo
{
     
    public class TText:TipoBase
    {
        /// <summary>
        /// Crea una nueva instancia del tipo TText
        /// </summary>
        /// <param name="ec"></param>
        /// <param name="pc"></param>
        /// <param name="valor"></param>
        
        public  TText(Elemento ec, Propiedad pc, string valor,string cod)
        {
            Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
            this.ValoresEP  = new ValoresEP(ec, pc, valor,idioma);      
            
            this.cargar(ValoresEP);
        }
        /// <summary>
        /// Crea una nueva instancia a traves del metodo cargar
        /// </summary>
        /// <param name="vc"></param>
        public TText(ValoresEP vc)
        {
            this.cargar(vc);
        }

        private TText() { }

        public List<ValoresEP> vcs;

        protected  void cargar(ValoresEP vc)
        {
            this.vcs = new List<ValoresEP>();
            if(vc!=null)
                 this.vcs = vc.Elemento.ValoresEP.Where(v => v.Propiedad.Id == vc.Propiedad.Id).ToList();
                

        }

        /// <summary>
        /// Indexador, para obtener un valor pasar el codigo de idioma por indice.
        /// Para agregar un nuevo valor asignar o modificar uno existente pasar el codigo de idioma por indice., automaticamente se ejecutaran
        /// las operaciones pertinentes y se almacenara en la base de datos.
        ///
        /// </summary>
        /// <param name="cod"></param>
        /// <returns></returns>
        public string this[string cod]
        {
            get
            {
                Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
                ValoresEP vc = this.vcs.FirstOrDefault(v => v.Idioma.Id == idioma.Id);
                if(vc==null)
                    return string.Empty;

                return vc.Valor;
            }
            set
            {
              
                Idioma idioma = GestionDatos.Instance.devolverIdiomaPorCod(cod);
                ValoresEP vc = this.vcs.FirstOrDefault(v => v.Idioma.Id == idioma.Id);
                //Si ya contiene la propiedad la modifica
                if (vc != null)
                {
                    vc.Valor = value;
                    vc.guardarVEP();
                }
                //Si no, crea una nueva y la añade
                else
                {
                    
                    vc = new ValoresEP(this.Elemento, this.vcs[0].Propiedad, value, idioma);
                    this.vcs.Add(vc);
                }
            }
        }


        #region MetodosEstaticos
        public static TText Cargar(ValoresEP vep)
        {
            if (vep == null)
                return null;
            TText ttext = new TText();
            ttext.Id = vep.Id;
            ttext.ValoresEP = vep;
            ttext.cargar(vep);
            return ttext;
            




        }
        #endregion
       

       
    }
}
