﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Datos.Modelo;
using System.Collections;
namespace CoreLibrary.Datos
{
  public  interface IModeloReader
  {
      #region Consultas
      List<Elemento> cargarElemento();
      List<Propiedad> cargarPropiedades();
      List<Categoria> cargarCategoria();
      List<ValoresEP> cargarValoresEP();
      List<Idioma> cargarIdioma();
      List<CategoriaPropiedad> cargarCategoriaPropiedad();
      List<TraduccionPropiedad> cargarTraduccionPropiedad();
      List<Direccion> cargarDireccion();
     
      
      #endregion

      #region Inserciones
      void nuevoElemento(Elemento elemento);
      void nuevaPropiedad(Propiedad propiedad);
      void nuevoCategoria(Categoria categoria);
      void nuevaCategoriaPropiedad(CategoriaPropiedad categoriaPropiedad);
      void nuevaTraduccionPropiedad(TraduccionPropiedad  traduccionPropiedad);
      void nuevaValoresEP(ValoresEP vep);
      
      void nuevoIdioma(Idioma i);

      void nuevoListaElemento(List<Elemento> elementos);
      void nuevaListaPropiedad(List<Propiedad> propiedades);
      void nuevoListaCategoria(List<Categoria> categorias);
      void nuevaListaCategoriaPropiedad(List<CategoriaPropiedad> categoriaPropiedades);
      void nuevaListaTraduccionPropiedad(List<TraduccionPropiedad> traduccionPropiedades);
      void nuevaListaValoresEP(List<ValoresEP> vep);






      #endregion

      #region Actualizaciones
      void actualizarElemento(Elemento elemento);
      void actualizarPropiedad(Propiedad propiedad);
      void actualizarCategoria(Categoria categoria);


      void actualizarListaElementos(List<Elemento> elementos);
      void actualizarListaPropiedad(List<Propiedad> propiedades);
      void actualizarListaCategoria(List<Categoria> categorias);



     // void actualizarDireccion(Direccion direccion);
      void actualizarListaTraduccionPropiedad(List<TraduccionPropiedad> traduccionPropiedad);
      void actualizarListaValoresEP(List<ValoresEP> vep);


      void actualizarTraduccionPropiedad(TraduccionPropiedad traduccionPropiedad);
      void actualizarValoresEP(ValoresEP vep);
      #endregion
  }
}
