﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.Collections;
using CoreLibrary.Datos;

namespace CoreLibrary.Datos.Modelo
{
    
   
    public  abstract class ControladorBase: IComparable    {
        #region Variables
        protected bool __baja;
        protected int __id;
        protected string __nombre;
       
        #endregion
        public override string ToString()
        {
            return this.Nombre;
        }


        private State _state;
        [XmlIgnore]
        public State State
        {
            get { return _state; }
            set 
            {
                if(this.Nombre!=null && this.Nombre.Contains("Nombre"))
                {
                    
                    ToString();               
                }

                if (this.State == State.New && value == State.Modify)
                    return;
               
                _state = value; 
            }
        }

        public int Size
        {
            get
            {
                return (100+ sizeof(int) + sizeof(bool));

            }

        }
        /// <summary>
        /// Compara los elemetosPorElId
        /// -1 si este es menor
        /// 0 si son iguales
        /// +1 si el pasado por parametro es mayor
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public int CompareTo(object o)
        {
            ControladorBase other = (ControladorBase)o;
            if (this.Id < other.Id)
                return -1;
            if (this.Id == other.Id)
                return 0;
            return 1;

        }



        #region Valores
        [XmlAttribute]
        public int Id
        {
            get
            {
                return this.__id;
            }
            set
            {
                
                this.__id = value;
               
            }
        }
        [XmlAttribute]
        public string Nombre
        {
            get
            {
                return this.__nombre;
            }
            set
            {
               
               
                this.__nombre = value;
               
            }
        }
        [XmlAttribute]
        public bool Baja
        {
            get
            {
                return this.__baja;
            }
            set
            {
                this.__baja = value;
              
            }
        }

        #endregion
    }
}
