using System;
using System.Collections.Generic;
using CoreLibrary.Datos;
using System.Linq;
using CoreLibrary;
using CoreLibrary.Controlador.Colecciones;
using System.Xml.Serialization;
namespace CoreLibrary.Datos.Modelo
{
	
	/// <summary>
	/// Clase en la que se almacena el valor de una propiedad.
	/// </summary>
	public class ValoresEP:ControladorBase
    {
        #region Constructor
        public ValoresEP()
        { }
        public ValoresEP(Elemento e,Propiedad p, object valor, Idioma idioma=null )
        {
            this.Id = GestionDatos.Instance.devolverProximoIdVEP();
            this._idElemento = e.Id;
            this._idPropiedad = p.Id;
            this._valor = valor.ToString();
            if (idioma != null)
                this._idIdioma = idioma.Id;
            GestionDatos.Instance.guardarValorPropiedad(this);
            
        }
        #endregion
        #region Variables
        int _idElemento, _idPropiedad, _idIdioma;
        [XmlAttribute]
        public int IdIdioma
        {
            get { return _idIdioma; }
            set { _idIdioma = value; }
        }
        [XmlAttribute]
        public int IdPropiedad
        {
            get { return _idPropiedad; }
            set { _idPropiedad = value; }
        }
        [XmlAttribute]
        public int IdElemento
        {
            get { return _idElemento; }
            set { _idElemento = value; }
        }
		string _valor;

        
        #endregion
        #region Propiedades
        [XmlIgnore]
        public string Nombre
        {
            get
            {
                return this.Propiedad.Nombre;
            }
            set
            {
            }

        }
        [XmlAttribute]
		public string Valor {
			get {
				return this._valor;
			}
			set {

				_valor = value;
			}
		}
         [XmlIgnore]
        public int Size
        {
            get
            {
                return base.Size + sizeof(int)*3 + Valor.Length*8;
            }
        }

          [XmlIgnore]
        public Idioma Idioma
        {
            get
            {
                return GestionDatos.Instance.Idiomas.FirstOrDefault(i => i.Id == this._idIdioma);
            }
        }
          [XmlIgnore]
        public Elemento Elemento
        {
            get
            {
                return GestionDatos.Instance.Elementos.FirstOrDefault(e => e.Id == this._idElemento);
            }

        }
          [XmlIgnore]
        public Propiedad Propiedad
        {
            get
            {
                return GestionDatos.Instance.Propiedades.FirstOrDefault(p => p.Id == this._idPropiedad);
            }

        }
          [XmlIgnore]
        public List<Categoria> Categorias
        {
            get
            {
               return this.Propiedad.Categorias;
            }
        }
          [XmlIgnore]
        public string TipoPrimitivo
        {
            get
            {
                return Propiedad.TipoPrimitivo;
            }
        }

        #endregion
        #region Metodos Publicos

        public override string ToString()
        {
            return this.Nombre.ToUpper()+"  " + this.Valor;
        }

        public void guardarVEP()
        {
            GestionDatos.Instance.modificarValor(this);
        }
        public bool comprobarSiPerteneceALaCategoria(string categoria)
        {
            
            return this.Propiedad.comprobarSiPertenceALaCategoria(categoria);

        }
        #endregion
    }
}

