using System;
using System.Collections.Generic;
using System.Linq;

using MonoTouch.Foundation;
using MonoTouch.UIKit;

using GuideLibrary;
using GuideLibrary.Places;
using GuideLibrary.Weather;

namespace CanaryGuideMT
{
	// The UIApplicationDelegate for the application. This class is responsible for launching the 
	// User Interface of the application, as well as listening (and optionally responding) to 
	// application events from iOS.
	[Register ("AppDelegate")]
	public partial class AppDelegate : UIApplicationDelegate
	{
		// class-level declarations
		UIWindow window;
		UITabBarController _tabBar;
		

		//
		// This method is invoked when the application has loaded and is ready to run. In this 
		// method you should instantiate the window, load the UI into it and then make the window
		// visible.
		//
		// You have 17 seconds to return from this method, or iOS will terminate your application.
		//
		public override bool FinishedLaunching (UIApplication app, NSDictionary options)
		{
			// create a new window instance based on the screen size
			window = new UIWindow (UIScreen.MainScreen.Bounds);
			
			//Se instancia GestionGuide y se generan los datos (Solo la primera vez)
			ScriptCanaryGuide.run();
	
			GestionGuide.Instance.GoogleWeather.getTime("Tenerife");
			
			
			
			
			//Se crean las pantallas principales
			
			//Places
			DialogPlace dp = new DialogPlace();
			dp.Nav.TabBarItem.Title = "Places";
			dp.Nav.TabBarItem.Image = UIImage.FromFile("Icons/Car.png");
			GestionGuide.Instance.GooglePlaces.ESearchDownloadComplete+=dp.generarTablaPlaces;
			GestionGuide.Instance.GooglePlaces.getSearch(28.091366,-15.820312);
			
			//Weather
			DialogWeather dw = new DialogWeather();
			dw.Nav.TabBarItem.Title="Wheather";
			dw.Nav.TabBarItem.Image = UIImage.FromFile("Icons/Weather.png");
			GestionGuide.Instance.GoogleWeather.EDownloadComplete+=dw.weatherDownloadComplete;
			//Lugar interes
			DialogLugarDeInteres dldi = new DialogLugarDeInteres();
			dldi.Nav.TabBarItem.Title="Lugar";
			dldi.Nav.TabBarItem.Image = UIImage.FromFile("Icons/Walk.png");
			
			
			
			_tabBar = new UITabBarController();
			//Se agregan los componentes creados al TabBar
			_tabBar.ViewControllers = new UIViewController[]{dldi.Nav,dp.Nav ,dw.Nav};
			
			
			// make the window visible
			window.RootViewController=_tabBar;
			window.MakeKeyAndVisible ();
			
			return true;
		}
	}
}

