using System;
using System.Collections.Generic;
using System.Linq;

using MonoTouch.Foundation;
using MonoTouch.UIKit;
using MonoTouch.Dialog;

using GuideLibrary;

using CoreLibrary.Datos;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Controlador.Filtros;
namespace CanaryGuideMT
{
	public partial class DialogLugarDeInteres : DialogViewController
	{
		
		
		
		
		//El navigarion tiene que ser publico para poder navegar hacia adelante y hacia atras
		public UINavigationController Nav {get;set;}
		private UIBarButtonItem _button;
		
		
		//Lista de lugares de interes
		List<LugarDeInteres> lugaresDeInteres  {get;set;}
		
		public DialogLugarDeInteres () : base (UITableViewStyle.Grouped, null)
		{
			this.TableView.RowHeight=75;//Tamaño de la tabla, ver mas opciones personalizacion.
						
			Root = new RootElement ("Lugar de interes");
			Nav = new UINavigationController(this); //se añade la tabla al navigation controller.
			Nav.NavigationBar.TintColor = UIColor.Black;
			
			
			//Se instanscia el botón superior y la vista a la que llama
			_button = new UIBarButtonItem(UIBarButtonSystemItem.Action);
			this.NavigationItem.RightBarButtonItem=_button;
			_button.Clicked+=(sender,e)=>{
				//Código que genera la pantalla	
				
				rellenarPantallFiltrosLugarDeInteres(this.lugaresDeInteres);				
			};
			//Se termina de instanciar el boton y se instancian los datos de la clase
			this.lugaresDeInteres = GestionGuide.Instance.LugaresDeInteres;
			
			generarTablaLugarDeInteres(this.lugaresDeInteres);
			
					
		}
		
		//Genera la tabla de sitios por defecto.
		private void generarTablaLugarDeInteres(List<LugarDeInteres> ldis)
		{
			this.Root = new RootElement("Lugar de interes");
			Section s = new Section();//Seccion principal
			
			foreach (var ldi in ldis) //Para cada LDI se crea un una nueva ventana.
			{
				RootLugarDeInteres rld = new RootLugarDeInteres(ldi);
				s.Add(rld);		
			}
			
			
			
			this.Root.Add(s);
			
			
		}
		
		
			
			
		
		                  
		
		protected void ElementTapped(object sender)
		{
			string texto = ((ElementEO)sender).Caption;
			
			if(texto.Contains("all"))
				this.lugaresDeInteres = GestionGuide.Instance.LugaresDeInteres;		
			else if(texto.Contains("[X]"))
		    {
				GestionGuide.Instance.FiltrosLugares.Remove(texto.Substring(0, texto.Length - 4));//Necesario porque aqui se pierden las referencias anteriores.
				string [] filtros = new string[GestionGuide.Instance.FiltrosLugares.Count];
				GestionGuide.Instance.FiltrosLugares.CopyTo(filtros);//Se copian los filtros ya que en el siguiente paso se inicializan.
				
				this.lugaresDeInteres = GestionGuide.Instance.LugaresDeInteres;
				//Se aplican todos los filtros
				foreach (var filtro in filtros) {
					ElementoOcurrencia EO = ElementoOcurrencia.fromString(filtro);
					GestionGuide.Instance.FiltrosLugares.Add(EO.Nombre);
				this.lugaresDeInteres = FiltroTBool<LugarDeInteres>.aplicarFiltro(this.lugaresDeInteres,EO,GestionGuide.Instance.Cod);
					}
			
			}else
			{
				ElementoOcurrencia EO = ElementoOcurrencia.fromStringEntero(texto);
				GestionGuide.Instance.FiltrosLugares.Add(EO.Nombre);		
				this.lugaresDeInteres=CoreLibrary.Controlador.Filtros.FiltroTBool<LugarDeInteres>.aplicarFiltro(this.lugaresDeInteres,EO,GestionGuide.Instance.Cod);
			
		}
			this.rellenarPantallFiltrosLugarDeInteres(this.lugaresDeInteres);
			this.generarTablaLugarDeInteres(this.lugaresDeInteres);
			this.DismissModalViewControllerAnimated(true);
			
		}	

		//Crea dinámicamente los filtros que se van a mostrar al pulsar el boton
		private void rellenarPantallFiltrosLugarDeInteres(List<LugarDeInteres> ldis )
		{
			DialogViewController dv = new DialogViewController(new RootElement("Sitio"));
			
			
			Section sec = new Section();
			List<Propiedad> propiedades= GestionDatos.Instance[LGuide.AtributoLugarDeInteres].Propiedades;
			List<ElementoOcurrencia> eos = FiltroTBool<LugarDeInteres>.generarFiltro(ldis,propiedades,GestionGuide.Instance.Cod);
			
			string texto="all";
			ElementEO se = new ElementEO(texto);
			
			se.ElementTappedHandle+=ElementTapped;
			sec.Add(se);
			
			foreach (var eo in eos) {
				if(GestionGuide.Instance.FiltrosLugares.Contains(eo.Nombre))
					texto=eo.Nombre+ " [X]"; //CAMBIAR POR UN CHECKED
				else
					texto=eo.ToString();
				
				se = new ElementEO(texto);
				se.ElementTappedHandle+=ElementTapped;
				sec.Add(se);
			}
			
			dv.Root.Add(sec);
			//Se convierte en modal
           PresentModalViewController (dv, true);
			
		}
		
		
	
	}
}