using System;
using System.Collections.Generic;
using System.Linq;

using MonoTouch.Foundation;
using MonoTouch.UIKit;
using MonoTouch.Dialog;

using GuideLibrary;
using GuideLibrary.Places;
using CoreLibrary.Datos;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Controlador.Filtros;
namespace CanaryGuideMT
{
	public partial class DialogPlace : DialogViewController
	{
				
		//El navigarion tiene que ser publico para poder navegar hacia adelante y hacia atras
		public UINavigationController Nav {get;set;}
		private UIBarButtonItem _button;
		
		
		//Lista de lugares de interes
		List<Place> _places {get;set;}
		
		public DialogPlace () : base (UITableViewStyle.Grouped, null)
		{
			this.TableView.RowHeight=75;//Tamaño de la tabla, ver mas opciones personalizacion.
				
			Root = new RootElement ("Lugar de interes");
			Nav = new UINavigationController(this); //se añade la tabla al navigation controller.
		    	Nav.NavigationBar.TintColor = UIColor.Black;
			//Se instanscia el botón superior y la vista a la que llama
			_button = new UIBarButtonItem(UIBarButtonSystemItem.Action);
			this.NavigationItem.RightBarButtonItem=_button;
			_button.Clicked+=(sender,e)=>{
				//Código que genera la pantalla
				if(this._places!=null)
					this.rellenarPantallaPlaces();		
			};
	
				
					
		}
		
		//Genera la tabla de sitios por defecto.
		public void generarTablaPlaces()
		{
			this._places=GestionGuide.Instance.GooglePlaces.sitios;
			this.Root = new RootElement("Places");
			Section s = new Section();
			
			foreach (var p in _places)//GestionGuide.Instance.GooglePlaces.sitios) 
				s.Add(new RootPlace(p)); 
			//Falta añadir el acceso a la siguiente ventana.
			this.Root.Add(s);
			
			
		}
		public void generarTablaPlaces(List<Place> places)
		{
				
			this.Root = new RootElement("Places");
			Section s = new Section();
			
			foreach (var p in places)//GestionGuide.Instance.GooglePlaces.sitios) 
				s.Add(new RootPlace(p)); 
			//Falta añadir el acceso a la siguiente ventana.
			this.Root.Add(s);
			
			
		}
		//esto es un pequena prueba 
		
		protected void ElementTapped(object sender)
		{
			string texto = ((ElementEO)sender).Caption;
			
			if(texto.Contains("all"))
				this._places = GestionGuide.Instance.GooglePlaces.sitios;		
			else if(texto.Contains("[X]"))
		    {
				GestionGuide.Instance.GooglePlaces.filtrosAplicados.Remove(texto.Substring(0, texto.Length - 4));//Necesario porque aqui se pierden las referencias anteriores.
				string [] filtros = new string[GestionGuide.Instance.GooglePlaces.filtrosAplicados.Count];
				GestionGuide.Instance.GooglePlaces.filtrosAplicados.CopyTo(filtros);//Se copian los filtros ya que en el siguiente paso se inicializan.
				
				this._places = GestionGuide.Instance.GooglePlaces.sitios;
				//Se aplican todos los filtros
				foreach (var filtro in filtros) {
					this._places = GestionGuide.Instance.GooglePlaces.getPlaceWithFilter(filtro,_places);
					}
			
			}else
				 _places = GestionGuide.Instance.GooglePlaces.getPlaceWithFilter(ElementoOcurrencia.fromStringEntero(texto).Nombre, _places);
        
			generarTablaPlaces(_places);
         
			this.DismissModalViewControllerAnimated(true);
		}
		
		 
		//Crea dinámicamente los filtros que se van a mostrar al pulsar el boton
		private void rellenarPantallaPlaces()
		{
			DialogViewController dv = new DialogViewController(new RootElement("Sitio"));
			
			Section sec = new Section();
			
			IEnumerable<string> palabras = this._places.SelectMany(t =>t.Tipo);
            List<ElementoOcurrencia> elementosO = new List<ElementoOcurrencia>();
            foreach (var p in palabras)
                new ElementoOcurrencia(p).incrementarAñadirLista(elementosO);
			
			
			
			string texto="all";
			ElementEO se = new ElementEO(texto);
			se.ElementTappedHandle+=ElementTapped;
			sec.Add(se);
			foreach (var eo in elementosO) {
				if(GestionGuide.Instance.GooglePlaces.filtrosAplicados.Contains(eo.Nombre))
					texto=eo.Nombre+ " [X]"; //CAMBIAR POR UN CHECKED
				else
					texto=eo.ToString();
				
				se = new ElementEO(texto);
				se.ElementTappedHandle+=ElementTapped;
				sec.Add(se);
			}
			
			dv.Root.Add(sec);
			//Se convierte en modal
           PresentModalViewController (dv, true);
			
		}
		
		
	
	}
}