using System;
using System.Collections.Generic;

using MonoTouch.Dialog;
using MonoTouch.UIKit;
using MonoTouch.Foundation;
using MonoTouch.ObjCRuntime;

using CanaryGuideMT.Celda;

using GuideLibrary.Places;


namespace CanaryGuideMT
{
	/// <summary>
	/// Root weather. Representa los datos de una sóla celda.
	/// </summary>
	public class RootPlace : Element
	{
		private Place p;
		private ViewControllerFicha _ficha;
		public RootPlace (Place p):base(null)
		{
			this.p=p;
			string description = "Tipo:";
			foreach (var tipo in p.Tipo) {
				description+="\n "+tipo;
			}
			
			double _lat =double.Parse(p.Latitud);
			double _lon =double.Parse(p.Longitud);
			
			
			_ficha=	new ViewControllerFicha(p.Nombre,description, p.Icon,_lat,_lon);
		}
		
		public override void Selected (DialogViewController dvc, UITableView tableView, NSIndexPath path)
		{
			dvc.NavigationController.PushViewController(_ficha,true);
			//base.Selected (dvc, tableView, path);
		}
	
		public override UITableViewCell GetCell (UITableView tv)
		{
			var cell =(CustomCell) tv.DequeueReusableCell("CellPlace");
			if(cell==null)
				cell = (CustomCell)Runtime.GetNSObject(NSBundle.MainBundle.LoadNib("CustomCell",new CustomCell(),null).ValueAt(0));
			
			string nombre=p.Nombre;
			if(p.Nombre.Length>20)
				 nombre= p.Nombre.Substring(0,20)+"...";
				
				

			
			
			cell.addDataToCell(p.Icon,nombre);
			cell.Accessory = UITableViewCellAccessory.DisclosureIndicator;
			return cell;
		}
		
	}
}

