using System;
using System.Drawing;

using MonoTouch.Foundation;
using MonoTouch.UIKit;

using MonoTouch.MapKit;
using MonoTouch.CoreLocation;

namespace CanaryGuideMT
{
	public partial class Mapa : UIViewController
	{
	
 	 private class MapViewDelegate : MKMapViewDelegate
	 {
     	
		public override MKAnnotationView GetViewForAnnotation (MKMapView Map, NSObject annotation)
		{
	    	
			if (annotation is MKUserLocation)
	       		  return null;
	     
			string reuseIdentifier = "MyAnnotation";
			var pinView = (MKPinAnnotationView) Map.DequeueReusableAnnotation(reuseIdentifier);
			if (pinView==null){							
			    pinView = new MKPinAnnotationView(annotation,reuseIdentifier);
			    pinView.PinColor = MKPinAnnotationColor.Red;
			    pinView.AnimatesDrop = true;
			    pinView.CanShowCallout = true;
			  }
	   	 return pinView;
	    }
			
	}
		
		
		
		CLLocationCoordinate2D _coordenas;
		string _text;
		
		public Mapa (string tex,double lat, double lon) : base ("Mapa", null)
		{
			_coordenas = new CLLocationCoordinate2D(lat,lon);
			_text = tex;
		}
		
		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}
		
		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			 this.Map.ShowsUserLocation = true;
  			 this.Map.Delegate = new MapViewDelegate();
			
		     MKPointAnnotation myAnnotation = new MKPointAnnotation();
     		 myAnnotation.Coordinate = _coordenas;
     		 myAnnotation.Title = _text;
     		 this.Map.AddAnnotation(myAnnotation);
			 this.Map.SetRegion(MKCoordinateRegion.FromDistance(_coordenas, 5000 , 5000), true);

		
		}
		
		public override void ViewDidUnload ()
		{
			base.ViewDidUnload ();
			
			// Clear any references to subviews of the main view in order to
			// allow the Garbage Collector to collect them sooner.
			//
			// e.g. myOutlet.Dispose (); myOutlet = null;
			
			ReleaseDesignerOutlets ();
		}
		
		public override bool ShouldAutorotateToInterfaceOrientation (UIInterfaceOrientation toInterfaceOrientation)
		{
			// Return true for supported orientations
			return (toInterfaceOrientation != UIInterfaceOrientation.PortraitUpsideDown);
		}
	}
}

