using System;
using System.Drawing;

using MonoTouch.Foundation;
using MonoTouch.UIKit;
using MonoTouch.CoreLocation;
using MonoTouch.MapKit;
using MonoTouch.Dialog;
namespace CanaryGuideMT
{
	public partial class ViewControllerFicha : UIViewController
	{
		public string Nombre{get;set;}
		public UIImage Imagen{get;set;}	
		public string Descripcion{get;set;}
		private Mapa _mapa;
		private double _lat,_lon;
		public ViewControllerFicha (string nombre,string descripcion, UIImage imagen,double lat,double lon) : base ("ViewControllerFicha", null)
		{
			this.Nombre=nombre;
			this.Imagen = imagen;	
			this.Descripcion=descripcion;
			this._lat=lat;
			this._lon=lon;
		}
		
		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}
		
		public override void ViewDidLoad ()
		{
		
			base.ViewDidLoad ();
			this.LabelName.Text=this.Nombre;
			this.TextDescription.Editable=false;
			this.TextDescription.Text=this.Descripcion;
			
			var _image = new UIImageView(Imagen);
			_image.Frame=this.Image.Frame;
			this.Image.AddSubview(_image);
			
			_mapa=new Mapa(Nombre,_lat,_lon);
			this.ButtonMapa.TouchUpInside+=(object seder, EventArgs e)=>
			{
			this.NavigationController.PushViewController(_mapa,true);	
				
				
			};
			
		}
		public override void ViewDidUnload ()
		{
			base.ViewDidUnload ();
			// Clear any references to subviews of the main view in order to
			// allow the Garbage Collector to collect them sooner.
			//
			// e.g. myOutlet.Dispose (); myOutlet = null;
			
			ReleaseDesignerOutlets ();
		}
	
		
		public override bool ShouldAutorotateToInterfaceOrientation (UIInterfaceOrientation toInterfaceOrientation)
		{
			// Return true for supported orientations
			return (toInterfaceOrientation != UIInterfaceOrientation.PortraitUpsideDown);
		}
	}
}

