using System;
using System.Collections.Generic;
using System.Linq;

using MonoTouch.Foundation;
using MonoTouch.UIKit;
using MonoTouch.Dialog;

using GuideLibrary;
using GuideLibrary.Weather;
namespace CanaryGuideMT
{
	public partial class DialogWeather : DialogViewController
	{
		//El navigarion tiene que ser publico para poder navegar hacia adelante y hacia atras
		public UINavigationController Nav {get;set;}
		private UIBarButtonItem _button;
		
		public DialogWeather () : base (UITableViewStyle.Grouped, null)
		{
			this.TableView.RowHeight=80;//Tamaño de la tabla, ver mas opciones personalizacion.
			
			
			Root = new RootElement ("Weather");
			Nav = new UINavigationController(this); //se añade la tabla al navigation controller.
			//Se instanscia el botón superior y la vista a la que llama
			Nav.NavigationBar.TintColor = UIColor.Black;
			_button = new UIBarButtonItem(UIBarButtonSystemItem.Action);
			this.NavigationItem.RightBarButtonItem=_button;
			_button.Clicked+=(sender,e)=>{
				//Código que genera la pantalla
				DialogViewController dv = new DialogViewController(new RootElement("Sitio"));
				Section sec = new Section();
				dv.Root.Add(sec);		
				string[] sitios = {"Tenerife","Gran Canaria","Fuerteventura","Lanzarote","El Hierro","La Gomera"};
				
				foreach (var sitio in sitios) {
					StringElement se = new StringElement(sitio,()=>{
						GestionGuide.Instance.GoogleWeather.getTime(sitio);
						this.ParentViewController.DismissModalViewControllerAnimated(true);}				
					);
					sec.Add(se);
					
				}	
				
           		PresentModalViewController (dv, true);
			
			};
			
			//Se genera el contenido de la Tabla
			Section s = new Section();
			
		
			//BARRA DE PROGRESO???
			Root.Add(s);
					
			
		}
		
		
		public void weatherDownloadComplete()
		{
			this.Root = new RootElement ("Weather");
			Section s = new Section();
			
			foreach (var t in GestionGuide.Instance.GoogleWeather.Temperaturas) 
				s.Add(new RootWeather(t));			
			this.Root.Add(s);
			this.LoadView();
			
		}
		
		
		
		
		
		
		
	}
}
