﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Literales;
using CoreLibrary.Datos;
using CoreLibrary.Controlador.Colecciones;
using CoreLibrary.Controlador.Tipo;

namespace GuideLibrary
{
    public class LugarDeInteres : Elemento
    {
          
          public LugarDeInteres(){}
          public LugarDeInteres(string nombre)
            : base(nombre)
        {
           
            //Se asocia el elemento con la propiedad (explicitamente) y categoria (implicitamente).
            Propiedad propiedadFood = GestionDatos.Instance.Propiedades.FirstOrDefault(p => p.Nombre.Equals(LGuide.LugarDeInteres));
            new ValoresEP(this, propiedadFood, true);
           
            //Se asocia a todos los atributos y se ponen en false
            Categoria cc = GestionDatos.Instance[LGuide.AtributoLugarDeInteres];
            foreach(Propiedad pc in cc.Propiedades)
                this.Atributos.Add(new Atributo(this, pc.Nombre, false));

            if(GestionGuide.Instance.LugaresDeInteres.FirstOrDefault(v=>v.Id==this.Id)==null)
                    GestionGuide.Instance.LugaresDeInteres.Add(this);
        }

          #region Metodos
          private void cargarAtributos()
          {
              //Se cargan todos las propiedades de la categoria AtributoELEMENTO
              _atributos = new CoreList<Atributo>();


              //Se buscan todos los atributos que pertenezcan a la categoria y no sean subcategoria.
              foreach (ValoresEP vep in this.ValoresEP.Where(v => v.comprobarSiPerteneceALaCategoria(LGuide.AtributoLugarDeInteres) &&
                        !v.TipoPrimitivo.Equals(LTipoPrimitivo.Categoria)))
                  _atributos.Add(Atributo.cargar(this, vep.Nombre));




          }
          #endregion

          #region Metodos estataticos
          internal static LugarDeInteres cargarFood(Elemento elemento)
          {
              LugarDeInteres video = new LugarDeInteres();
              video.Id = elemento.Id;
              video.__nombre = elemento.Nombre;
              video.__baja = elemento.Baja;
              return video;

          }
          #endregion
          private CoreList<Atributo> _atributos;
          public CoreList<Atributo> Atributos
          {
              get
              {
                  if (_atributos == null)
                      this.cargarAtributos();
                  return _atributos;
              }


          }
          #region Propiedades
          public string ImagenURL
          {
              get
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.ImagenURL]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.ImagenURL], string.Empty);

                  return tString.Valor;
              }
              set
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.ImagenURL]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.ImagenURL], value);
                  else
                      tString.Valor = value;
              }

          }
        /// <summary>
        /// Una de las propiedades de TTEXT es que se debe asignar el texto de la siguiente manera: valor[cod]="texto"; No hay que volver a setear la propiedad.
        /// </summary>
          public  TText Descripcion
          {
              get
              {
                  TText tString = TText.Cargar(this[LGuide.Descripcion]);
                  if (tString == null)
                      tString = new TText(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.Descripcion], string.Empty,GestionGuide.Instance.Cod);

                  return tString;
              }
             

          }
          public string Longitud
          {
              get
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.Longitud]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.Longitud], string.Empty);

                  return tString.Valor;
              }
              set
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.Longitud]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.Longitud], value);
                  else
                      tString.Valor = value;
              }

          }
          public string Latitud
          {
              get
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.Latitud]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.Latitud], string.Empty);

                  return tString.Valor;
              }
              set
              {
                  TStringSimple tString = TStringSimple.Cargar(this[LGuide.Latitud]);
                  if (tString == null)
                      tString = new TStringSimple(this, GestionDatos.Instance[LGuide.LugarDeInteres][LGuide.Latitud], value);
                  else
                      tString.Valor = value;
              }

          }
    
    
    
    
    
          #endregion

         
    }
}
