﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Xml.Linq;
#if WINDOWS_PHONE
using ImageTools;
using ImageTools.IO.Png;
#endif
using System.Threading;
namespace GuideLibrary.Places
{
   
    public delegate void SearchDownloadComplete(); 
    public delegate void DetailsDownloadComplete();
    public class GooglePlaces
    {
        private const string KEY = "AIzaSyD_yP06i1AnYLZackHqKegKqzSQ7olkms0";


       private List<Place> _places;
       public List<Place> sitios
        {


            get
            {
                this.filtrosAplicados = new List<string>();
                return this._places;
            }

            set
            {
                this._places = value;
            }
        }
       public Place sitioDetalle {get;set;}
       public List<string> filtrosAplicados { get; set; }
       public event SearchDownloadComplete ESearchDownloadComplete;
       public event DetailsDownloadComplete EDetailsDownloadComplete;
     
        
        
        
        public GooglePlaces()
       {
           


       }

        public void getSearch(double latitud, double longitud, string tipos = "restaurant|bar|food|gym|health|hospital|pharmacy")
        {
            string url = string.Format("https://maps.googleapis.com/maps/api/place/search/xml?location={0},{1}&types={2}&language={3}&radius=520000&sensor=false&key={4}",
               latitud.ToString().Replace(',', '.'), longitud.ToString().Replace(',', '.'),tipos, GestionGuide.Instance.Cod, KEY);


            WebClient cliente = new WebClient();
            cliente.DownloadStringAsync(new Uri(url));
            cliente.DownloadStringCompleted += new DownloadStringCompletedEventHandler(Busqueda_DownloadStringCompleted);
        }


       private void Busqueda_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e) 
       {
           //TODO Hacer las comprobaciones pertinentes.
           if (e.Error != null)
           {

               return;
           }

           sitios = new List<Place>();
           XElement XMLCadena = XElement.Parse(e.Result);
           foreach (var nodo in XMLCadena.Nodes())
           {
               XElement elemento = (XElement)nodo;
               if (!elemento.Name.LocalName.Equals("result"))
                   continue;
               Place sitio = new Place();

               IEnumerable<XElement> tipos = elemento.Elements("type");
               sitio.Tipo = new List<string>();
               foreach (var etipo in tipos)
                   sitio.Tipo.Add(etipo.Value);

               sitio.Reference = elemento.Element("reference").Value;
               sitio.Nombre = elemento.Element("name").Value;
               
              
               sitio.Latitud =elemento.Element("geometry").Element("location").Element("lat").Value;
               sitio.Longitud = elemento.Element("geometry").Element("location").Element("lng").Value;
			   string imageUrl = (string)elemento.Element("icon").Value;
               
				
				
				 #if WINDOWS_PHONE
				ImageTools.IO.Decoders.AddDecoder<PngDecoder>();
               ImageTools.ExtendedImage image = new ImageTools.ExtendedImage();
               image.UriSource = new Uri(imageUrl, UriKind.Absolute);
               sitio.Icon = image;
          
				#elif MONO	
					sitio.Icon = MonoTouch.UIKit.UIImage.LoadFromData(MonoTouch.Foundation.NSData.FromArray(new WebClient().DownloadData(imageUrl)));
                #endif
				
				

               sitios.Add(sitio);

             //  this.getDetails(sitio);


           }
           ESearchDownloadComplete();



       }


   

    /// <summary>
    /// Obtiene los detalles de un lugar. Debe subscribirse al evento Details_DownloadComplete 
    /// </summary>
    /// <param name="place"></param>
        public void getDetails(Place place)
        {
            this.sitioDetalle = place;
            string url = string.Format("https://maps.googleapis.com/maps/api/place/details/xml?reference={0}&sensor=true&key={1}",place.Reference,KEY);
            WebClient cliente = new WebClient();
            cliente.DownloadStringAsync(new Uri(url));
            cliente.DownloadStringCompleted += new DownloadStringCompletedEventHandler(place.Detalles_DownloadStringCompleted);

        }

        



        public List<Place> getPlaceWithFilter(string filter)
        {
            this.filtrosAplicados.Add(filter);
            return this.sitios.Where(p => p.Tipo.Contains(filter)).ToList();
        }

        public List<Place> getPlaceWithFilter(string filter,List<Place> places)
        {
            this.filtrosAplicados.Add(filter);
            return places.Where(p => p.Tipo.Contains(filter)).ToList();
        }


    }
}
