﻿using System;
using System.Net;

using CoreLibrary.Datos;
using CoreLibrary.Datos.Modelo;
using CoreLibrary.Literales;
using System.Linq;
namespace GuideLibrary
{
    public static class ScriptCanaryGuide
    {
        public static void run()
        {
            crearIdiomas();
            crearCategorias();
            crearAtributosVideo();

            crearElementosDePueba();
            
            
            GestionDatos.Instance.saveAll();
        }

        private static void crearElementosDePueba()
        {
           
            GestionDatos gd = GestionDatos.Instance;
            if (gd[LGuide.AtributoLugarDeInteres]["Tenerife"] == null)
                new Propiedad("Tenerife", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Tenerife");
			if (gd[LGuide.AtributoLugarDeInteres]["Fuerteventura"] == null)
                new Propiedad("Fuerteventura", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Fuerteventura");
            
			if (gd[LGuide.AtributoLugarDeInteres]["Lanzarote"] == null)
                new Propiedad("Lanzarote", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Lanzarote");
  
			if (gd[LGuide.AtributoLugarDeInteres]["Playa"] == null)
                new Propiedad("Playa", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Playa");
			
			if (gd[LGuide.AtributoLugarDeInteres]["Montaña"] == null)
                new Propiedad("Montaña", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Montaña");
			if (gd[LGuide.AtributoLugarDeInteres]["Cueva"] == null)
				new Propiedad("Cueva", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Cueva");
			if (gd[LGuide.AtributoLugarDeInteres]["ParqueNacional"] == null)
                new Propiedad("ParqueNacional", LTipoPrimitivo.Bool, LGuide.AtributoLugarDeInteres).añadirTraduccion("es", "Parque Nacional");

            
            if(gd.Elementos.FirstOrDefault(p=>p.Nombre.Equals("El Teide"))==null)
            {      
                LugarDeInteres ldi = new LugarDeInteres("El Teide");
                ldi.Descripcion["es"] = "El Teide (en guanche y originariamente, Echeyde o Echeide1 ) es un volcán situado en la isla de Tenerife (Islas Canarias, España). Con una altura de 3.718 metros sobre el nivel del mar y 7.500 metros sobre el lecho oceánico, es el pico más alto de España, el de cualquier tierra emergida del Océano Atlántico y el tercer mayor volcán de La Tierra desde su base en el lecho oceánico, después del Mauna Kea y el Mauna Loa, ambos en la isla de Hawaii.2 La altura del Teide convierte además a la isla de Tenerife es la décima isla más alta de todo el mundo."+
										"\n El Teide forma parte del Parque Nacional del Teide, declarado Patrimonio de la Humanidad por la UNESCO, el 28 de junio de 2007 en Christchurch (Nueva Zelanda). Es además un espacio natural protegido en la categoría de Monumento Natural que encierra el complejo volcánico Teide-Pico Viejo, un gran estratovolcán de tipo vesubiano que aún se mantiene activo a tenor de las erupciones históricas ocurridas no hace demasiado tiempo (la última, la de Narices del Teide, en 1798) y las fumarolas que emite regularmente desde su cráter.";
				ldi.Latitud="28.279818";
				ldi.Longitud="-16.633644";
                ldi.ImagenURL = "Images/Teide.jpg";
                ldi.Atributos["Tenerife"].Valor = true;
                ldi.Atributos["Montaña"].Valor = true;
				ldi.Atributos["ParqueNacional"].Valor = true;
            }

            if (gd.Elementos.FirstOrDefault(p => p.Nombre.Equals("Grandes Playas")) == null)
            {
                LugarDeInteres ldi = new LugarDeInteres("Grandes Playas");
                ldi.Descripcion["es"] = "Las Grandes Playas son un conjunto de playas de Corralejo (La Oliva), en el municipio de La Oliva, de la isla de Fuerteventura. Está formada por las playas de:Los Martos,El Viejo,Larga,El Pozo,El Caserón Comprende en total una longitud de 3 kilómetros y medio y gran parte de ellas se encuentran dentro del Parque Natural de las Dunas de Corralejo, un bello y excepcional paraje natural. También se las conoce como las playas de los hoteles, debido a unos hoteles que son la única construcción dentro del paraje natural, que han sido muy discutidos por su emplazamiento." 
					+"Varias de las playas son nudistas, y algunas cuentan con pequeñas fortificaciones con cantos rodados y rocas a modo de cuevas o resguardos y como la mayoría de las playas naturales de la isla, son muy protegidas y cuidadas por los isleños.Debido a su gran extensión, la ocupación es baja, pese a ser uno de los lugares que más gente atrae. Tanto locales, como turistas."
					+"Se dan unas condiciones muy favorables para la práctica de los tres deportes acuáticos preferidos en la isla, como son, el surf, el windsurf y el kitesurf.";
				ldi.Latitud="28.71912";
				ldi.Longitud="-13.840928";
                ldi.ImagenURL = "Images/Corralejo.jpg";
                ldi.Atributos["Fuerteventura"].Valor = true;
				ldi.Atributos["Playa"].Valor = true;
				
            }
			
			
			
			  if (gd.Elementos.FirstOrDefault(p => p.Nombre.Equals("Playa de las Vistas")) == null)
            	{
                LugarDeInteres ldi = new LugarDeInteres("Playas de las Vistas");
                ldi.Descripcion["es"] = "La Playa de Las Vistas es una playa artificial localizada en el sur de Tenerife (Canarias, España). Es una de las playas que conforman la zona turística de Los Cristianos en el término municipal de Arona."
						+"Es una playa muy frecuentada tanto por residentes como por visitantes. Dispone de servicio de sombrillas, hamacas, duchas, aseos y socorristas. Mediante un paseo marítimo se encuentra conectada con las vecinas playas de Los Cristianos y El Camisón y a la zona turística anexa de Playa de Las Américas. En el centro de la playa emerge una isla artificial que actúa a modo de fuente despidiendo agua a su alrededor. También existe la posibilidad de alquilar diferentes servicios de deportes y actividades acuáticas."
						+"Esta playa ha sido galardonada con la Bandera Azul por la Fundación Europea Ambiental (FEEE) durante varios años.";            
				ldi.Latitud="28.049561";
				ldi.Longitud="-16.71454";
                ldi.ImagenURL = "Images/LasVistas.jpg";
                ldi.Atributos["Tenerife"].Valor = true;
				ldi.Atributos["Playa"].Valor = true;
            	}
			
			
			 
			 if (gd.Elementos.FirstOrDefault(p => p.Nombre.Equals("Timanfaya")) == null)
            	{
                LugarDeInteres ldi = new LugarDeInteres("Timanfaya");
                ldi.Descripcion["es"] = "El parque nacional de Timanfaya se encuentra en los municipios de Yaiza y Tinajo de la isla de Lanzarote, Islas Canarias."
										+"Fue declarado Parque Nacional el 9 de agosto de 1974. Ocupa una extensión de 51,07km² del suroeste de la isla. Se trata de un parque de origen volcánico. Las últimas erupciones se produjeron en el siglo XVIII, entre los años 1730 y 1736. Cuenta con más de 25 volcanes, siendo algunos emblemáticos, tales como las Montañas del Fuego, Montaña Rajada o la Caldera del Corazoncillo. Aún presenta actividad volcánica, existiendo puntos de calor en la superficie que alcanzan los 100-120C y 600C a 13 metros de profundidad."
										+"Este hábitat volcánico se encuentra en las primeras etapas de la sucesión ecológica (en total se encuentran unas 180 especies vegetales), por lo que es un lugar excelente para el estudio de los procesos de colonización y sucesión."
										+"En 1993, Unesco le otorgó la calificación de Reserva de la Biosfera a toda la isla. También es Zona de Especial Protección para las Aves (1994).";
				ldi.Latitud="29.01324";
				ldi.Longitud="-13.734627";
                ldi.ImagenURL = "Images/Timanfaya.jpg";
                ldi.Atributos["Lanzarote"].Valor = true;
				ldi.Atributos["Montaña"].Valor = true;
				ldi.Atributos["ParqueNacional"].Valor = true;
            	}
			
			 if (gd.Elementos.FirstOrDefault(p => p.Nombre.Equals("La Cueva de los Verdes")) == null)
            	{
                LugarDeInteres ldi = new LugarDeInteres("La Cueva de los Verdes");
				ldi.Descripcion["es"] = "La Cueva de los Verdes forma parte de un tubo volcánico situado al norte de la isla de Lanzarote, en el Archipiélago Canario (España). Se formó durante la erupción del Volcán de La Corona, hace aproximadamente 5000 años (erupción anterior a Timanfaya), cuando las lavas muy fluidas descendieron por debajo de lavas más compactas creando una gran cavidad alargada. El tubo tiene una longitud total de siete kilómetros desde el volcán de la Corona hasta la costa, prologándose su recorrido bajo el mar en el conocido como Túnel de la Atlántida durante 1500 metros, siendo así porque el nivel del mar (durante la última glaciación) estaba 80 metros por debajo del nivel actual, convirtiéndolo así en el túnel volcánico más largo del mundo."
				+"En la parte más cercana a la costa de dicho tubo volcánico, se sitúan los Jameos del agua."
				+"La cueva fue utilizada por la población local para refugiarse de los ataques de corsarios berberiscos que periódicamente asolaban la isla, recibiendo el nombre de Cueva de los Verdes, porque la familia Verdes era la propietaria de las tierras en las que se encuentra la cueva."
				+"En el año 1964 se realizaron intervenciones de iluminación en el interior de la gruta para que pudiera ser visitada. Desde entonces forma parte de la red de Centros de Arte, Cultura y Turismo pertenecientes al Cabildo de Lanzarote. En su interior cuenta con un auditorio y rincones denominados como la sala de las estetas, la garganta de la muerte o la puerta mora. También se puede encontrar estafilitos y las líneas que indican los niveles de lava."
				+"En la cueva se encuentra ubicado además el núcleo principal de la estación geodinámica de Lanzarote";
				ldi.Latitud="29.161606";
				ldi.Longitud="-13.439198";
                ldi.ImagenURL = "Images/CuevaVerdes.jpg";
               ldi.Atributos["Lanzarote"].Valor = true;
				ldi.Atributos["Cueva"].Valor = true;
            	}
			
			
			
			
			
			
			
			
        }


        private static void crearAtributosVideo()
        {
            GestionDatos gd = GestionDatos.Instance;

            if (gd[LGuide.LugarDeInteres][LGuide.ImagenURL] == null)
                new Propiedad(LGuide.ImagenURL, LTipoPrimitivo.TStringSimple, LGuide.LugarDeInteres);

            if (gd[LGuide.LugarDeInteres][LGuide.Longitud] == null)
                new Propiedad(LGuide.Longitud, LTipoPrimitivo.TStringSimple, LGuide.LugarDeInteres);


            if (gd[LGuide.LugarDeInteres][LGuide.Latitud] == null)
                new Propiedad(LGuide.Latitud, LTipoPrimitivo.TStringSimple, LGuide.LugarDeInteres);


            if (gd[LGuide.LugarDeInteres][LGuide.Descripcion] == null)
                new Propiedad(LGuide.Descripcion, LTipoPrimitivo.TStringSimple, LGuide.LugarDeInteres);

          
        
        }
        private static void crearCategorias()
        {
            GestionDatos gd = GestionDatos.Instance;

            if (gd[LGuide.LugarDeInteres] == null)
                new Categoria(LGuide.LugarDeInteres);

            if (gd[LRecursos.Recurso] == null)
                new Categoria(LRecursos.Recurso);
           
            if (gd[LGuide.AtributoLugarDeInteres] == null)
                new Categoria(LGuide.AtributoLugarDeInteres);

            if (gd[LGuide.LugarDeInteres][LGuide.LugarDeInteres] == null)
                new Propiedad(LGuide.LugarDeInteres, LTipoPrimitivo.Categoria, LGuide.LugarDeInteres);
         
         

        }
        private static void crearIdiomas()
        {
            GestionDatos gd = GestionDatos.Instance;

            if (gd.Idiomas.Count() == 0)
            {
                Idioma espaniol = new Idioma();
                espaniol.Id = 1;
                espaniol.Cod = "es";
                espaniol.Nombre = "Español";
                gd.guardarIdioma(espaniol);

                Idioma ingles = new Idioma();
                ingles.Id = 1;
                ingles.Cod = "en";
                ingles.Nombre = "Ingles";
                gd.guardarIdioma(ingles);

                Idioma aleman = new Idioma();
                aleman.Id = 1;
                aleman.Cod = "de";
                aleman.Nombre = "Aleman";
                gd.guardarIdioma(aleman);


            }
        }

    }
}
