﻿using System;
using System.Net;

using System.ComponentModel;
#if WINDOWS_PHONE
using ImageTools.IO.Gif;
using ImageTools;
using System.Xml.Linq;
#endif

using System.Xml.Linq;

using System.Collections.Generic;
namespace GuideLibrary.Weather
{
    public delegate void DownloadComplete();

    public class GoogleWeather
    {
        public event DownloadComplete EDownloadComplete;

        public List<Tiempo> Temperaturas { get; set; }


        public GoogleWeather()
        {



        }

        public void getTime(string localizacion)
        {
            WebClient webclient = new WebClient();
            webclient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(WebClient_DownloadCompleted);
            webclient.DownloadStringAsync(new Uri("http://www.google.com/ig/api?weather=" + localizacion + "&hl=" + "es" + "&oe=utf-8")); // weather location

        }


        protected void WebClient_DownloadCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                return;
                throw new Exception("Ha ocurrido un error");//TODO Cambiar al idioma correspondiente.

            }
            Temperaturas = new List<Tiempo>();

            XElement XMLTemperatura = XElement.Parse(e.Result);
            foreach (var elemento in XMLTemperatura.Descendants("forecast_conditions"))
            {
                Tiempo t = new Tiempo();
                t.Dia = (string)elemento.Element("day_of_week").Attribute("data").Value;
                t.Max = (string)elemento.Element("high").Attribute("data").Value;
                t.Min = (string)elemento.Element("low").Attribute("data").Value;
                t.Condicion = (string)elemento.Element("condition").Attribute("data").Value;

                string gifUrl = "http://www.google.com/" + (string)elemento.Element("icon").Attribute("data").Value;

                #if WINDOWS_PHONE
                ImageTools.IO.Decoders.AddDecoder<GifDecoder>();
                ImageTools.ExtendedImage image = new ImageTools.ExtendedImage();

                image.UriSource = new Uri(gifUrl, UriKind.Absolute);
                t.Icon = image;
				#elif MONO	
				t.Icon = MonoTouch.UIKit.UIImage.LoadFromData(MonoTouch.Foundation.NSData.FromArray(new WebClient().DownloadData(gifUrl)));
                #endif



                Temperaturas.Add(t);



            }

            EDownloadComplete();

        }






    }
}
